#include "stdafx.h"

const int iDstBitDepth = 10;
const int iSrcBitDepth = 8;

#define UYVY_YUV422P10_AVX2_TOP()				\
	for (x = uNum; x; x--)							\
{												\
	y1 = _mm256_lddqu_si256((__m256i*)(pSrcY));		\
	y2 = _mm256_lddqu_si256((__m256i*)(pSrcY + 32));	\
	y3 = _mm256_and_si256(y1, mMask);				\
	y4 = _mm256_and_si256(y2, mMask);				\
	y1 = _mm256_srli_epi16(y1, 8);					\
	y2 = _mm256_srli_epi16(y2, 8);					\
	y1 = _mm256_slli_epi16(y1, 2);					\
	y2 = _mm256_slli_epi16(y2, 2);					\
	y3 = _mm256_packus_epi16(y3, y4);				\
	y3 = _mm256_permute4x64_epi64(y3, 0xD8);		\
	y4 = _mm256_and_si256(y3, mMask);				\
	y3 = _mm256_srli_epi16(y3, 8);					\
	y4 = _mm256_slli_epi16(y4, 2);					\
	y3 = _mm256_slli_epi16(y3, 2);					\
	_mm256_storeu_si256((__m256i*)(pDstY), y1);		\
	_mm256_storeu_si256((__m256i*)(pDstY + 16), y2);	\
	_mm256_storeu_si256((__m256i*)(pDstU), y4);		\
	_mm256_storeu_si256((__m256i*)(pDstV), y3);		\
	pSrcY += uStep<<1;							\
	pDstY += uStep;								\
	pDstU += uStep>>1;							\
	pDstV += uStep>>1;							\
}

#ifdef _AVX2
void UYVYToYUV422P10DI_avx2(PBYTE pbDstY, PBYTE pbDstU, PBYTE pbDstV, INT iDstYStride, INT iDstUvStride,
	PBYTE pbSrcY, PBYTE pbSrcU, PBYTE pbSrcV, INT iSrcYStride, INT iSrcUvStride,
	UINT uWidth, INT iHeight)
{
	INT iSrcShift = (iDstBitDepth - iSrcBitDepth) < 0 ? 0 : (iDstBitDepth - iSrcBitDepth);
	INT iDstShift = (iSrcBitDepth - iDstBitDepth) < 0 ? 0 : (iSrcBitDepth - iDstBitDepth);

	SrcT *pSrcY = (SrcT *)pbSrcY;
	DstT *pDstY = (DstT *)pbDstY;
	DstT *pDstU = (DstT *)pbDstU;
	DstT *pDstV = (DstT *)pbDstV;
	INT uStep = 0;
	INT uNum = uWidth;
	__m256i y1, y2, y3, y4, y5, y6, y7, y8;
	__m256i u1, u2, u3, u4, u5, u6;
	INT x;
	__m256i mZero = _mm256_setzero_si256();
	__m256i mMask = _mm256_set1_epi16(0xFF);
	__m256i mMask16 = _mm256_set1_epi32(0xFFFF);

	{
		uStep = 32;
		uNum = uWidth >> 5;
	}

	iSrcYStride >>= sizeof(SrcT) - 1;
	iDstYStride >>= sizeof(DstT) - 1;
	iDstUvStride >>= sizeof(DstT)- 1;

	if(iHeight < 0)
	{
		iHeight = -iHeight;
		pDstY += (iHeight-1) * iDstYStride;
		iDstYStride = -iDstYStride;
		iDstUvStride = -iDstUvStride;
	}

	INT iSrcYDif  = iSrcYStride - (uWidth<<1);
	INT iDstUvDif = iDstUvStride - (uWidth>>1);
	INT iDstYDif  = iDstYStride - uWidth;
	INT iH = iHeight - 2;

	//top line
	{
		UYVY_YUV422P10_AVX2_TOP();

		for(x = uWidth & (uStep - 1); x; x -= 2)
		{
			pDstY[0] = (DstT)_BitConv(pSrcY[1], iSrcShift, iDstShift);
			pDstY[1] = (DstT)_BitConv(pSrcY[3], iSrcShift, iDstShift);
			pDstU[0] = (DstT)_BitConv(pSrcY[0], iSrcShift, iDstShift);
			pDstV[0] = (DstT)_BitConv(pSrcY[2], iSrcShift, iDstShift);
			pDstY += 2;
			pDstU ++;
			pDstV ++;
			pSrcY += 4;
		}
		pDstY += iDstYDif;
		pDstU += iDstUvDif ;
		pDstV += iDstUvDif;
		pSrcY += iSrcYDif;
	}

	pSrcY -= iSrcYStride;

	for(int y = iH; y; y--)
	{

		for (x = uNum; x; x--)							
		{												
			y1 = _mm256_lddqu_si256((__m256i*)(pSrcY));		
			y2 = _mm256_lddqu_si256((__m256i*)(pSrcY + 32));	
			y3 = _mm256_lddqu_si256((__m256i*)(pSrcY + iSrcYStride));	
			y4 = _mm256_lddqu_si256((__m256i*)(pSrcY + iSrcYStride + 32));	
			y5 = _mm256_lddqu_si256((__m256i*)(pSrcY + iSrcYStride * 2));	
			y6 = _mm256_lddqu_si256((__m256i*)(pSrcY + iSrcYStride * 2 + 32));	
			u1 = _mm256_and_si256(y1, mMask);			
			u2 = _mm256_and_si256(y2, mMask);			
			u3 = _mm256_and_si256(y3, mMask);			
			u4 = _mm256_and_si256(y4, mMask);			
			u5 = _mm256_and_si256(y5, mMask);			
			u6 = _mm256_and_si256(y6, mMask);			
			y1 = _mm256_srli_epi16(y1, 8);					
			y2 = _mm256_srli_epi16(y2, 8);					
			y3 = _mm256_srli_epi16(y3, 8);					
			y4 = _mm256_srli_epi16(y4, 8);					
			y5 = _mm256_srli_epi16(y5, 8);					
			y6 = _mm256_srli_epi16(y6, 8);					
			y1 = _mm256_slli_epi16(y1, 2);					
			y2 = _mm256_slli_epi16(y2, 2);					
			y3 = _mm256_slli_epi16(y3, 2);					
			y4 = _mm256_slli_epi16(y4, 2);					
			y5 = _mm256_slli_epi16(y5, 2);					
			y6 = _mm256_slli_epi16(y6, 2);					
			u1 = _mm256_slli_epi16(u1, 2);					
			u2 = _mm256_slli_epi16(u2, 2);					
			u3 = _mm256_slli_epi16(u3, 2);					
			u4 = _mm256_slli_epi16(u4, 2);					
			u5 = _mm256_slli_epi16(u5, 2);					
			u6 = _mm256_slli_epi16(u6, 2);					
			y1 = _mm256_avg_epu16(y1, y5);					
			y2 = _mm256_avg_epu16(y2, y6);					
			y1 = _mm256_avg_epu16(y1, y3);					
			y2 = _mm256_avg_epu16(y2, y4);					
			u1 = _mm256_avg_epu16(u1, u5);					
			u2 = _mm256_avg_epu16(u2, u6);					
			u1 = _mm256_avg_epu16(u1, u3);					
			u2 = _mm256_avg_epu16(u2, u4);					
			u3 = _mm256_and_si256(u1, mMask16);			
			u4 = _mm256_and_si256(u2, mMask16);			
			u1 = _mm256_srli_epi32(u1, 16);				
			u2 = _mm256_srli_epi32(u2, 16);				
			u3 = _mm256_packus_epi32(u3, u4);				
			u1 = _mm256_packus_epi32(u1, u2);				
			u3 = _mm256_permute4x64_epi64(u3, 0xD8);		
			u1 = _mm256_permute4x64_epi64(u1, 0xD8);		
			_mm256_storeu_si256((__m256i*)(pDstY), y1);		
			_mm256_storeu_si256((__m256i*)(pDstY + 16), y2);	
			_mm256_storeu_si256((__m256i*)(pDstU), u3);		
			_mm256_storeu_si256((__m256i*)(pDstV), u1);		
			pSrcY += uStep<<1;							
			pDstY += uStep;								
			pDstU += uStep>>1;							
			pDstV += uStep>>1;							
		}

		for(x = uWidth & (uStep - 1); x; x -= 2)
		{
			pDstU[0] = (DstT)_DI_BOB_3(pSrcY[0], pSrcY[iSrcYStride],   pSrcY[iSrcYStride*2],   iSrcShift, iDstShift);
			pDstY[0] = (DstT)_DI_BOB_3(pSrcY[1], pSrcY[iSrcYStride+1], pSrcY[iSrcYStride*2+1], iSrcShift, iDstShift);
			pDstV[0] = (DstT)_DI_BOB_3(pSrcY[2], pSrcY[iSrcYStride+2], pSrcY[iSrcYStride*2+2], iSrcShift, iDstShift);
			pDstY[1] = (DstT)_DI_BOB_3(pSrcY[3], pSrcY[iSrcYStride+3], pSrcY[iSrcYStride*2+3], iSrcShift, iDstShift);

			pDstY +=2;
			pDstU ++;
			pDstV ++;
			pSrcY +=4;
		}

		pSrcY += iSrcYDif;
		pDstU += iDstUvDif;
		pDstV += iDstUvDif;
		pDstY += iDstYDif;
	}

	//bottom line
	{
		pSrcY += iSrcYStride;

		UYVY_YUV422P10_AVX2_TOP();

		for(x = uWidth & (uStep - 1); x; x -= 2)
		{
			pDstY[0] = (DstT)_BitConv(pSrcY[1], iSrcShift, iDstShift);
			pDstY[1] = (DstT)_BitConv(pSrcY[3], iSrcShift, iDstShift);
			pDstU[0] = (DstT)_BitConv(pSrcY[0], iSrcShift, iDstShift);
			pDstV[0] = (DstT)_BitConv(pSrcY[2], iSrcShift, iDstShift);
			pDstY += 2;
			pDstU ++;
			pDstV ++;
			pSrcY += 4;
		}
	}
}
#endif
