#include "stdafx.h"

const int iDstBitDepth = 10;
const int iSrcBitDepth = 8;

#define UYVY_YUV422P10_AVX2_TOP()				\
	for (x = uNum; x; x--)							\
{												\
	y1 = _mm512_loadu_si512((__m512i*)(pSrcY));		\
	y2 = _mm512_loadu_si512((__m512i*)(pSrcY + 64));	\
	y3 = _mm512_and_si512(y1, mMask);				\
	y4 = _mm512_and_si512(y2, mMask);				\
	y1 = _mm512_srli_epi16(y1, 8);					\
	y2 = _mm512_srli_epi16(y2, 8);					\
	y1 = _mm512_slli_epi16(y1, 2);					\
	y2 = _mm512_slli_epi16(y2, 2);					\
	y3 = _mm512_packus_epi16(y3, y4);				\
	y3 = _mm512_permutexvar_epi16(mIdx, y3);		\
	y4 = _mm512_and_si512(y3, mMask);				\
	y3 = _mm512_srli_epi16(y3, 8);					\
	y4 = _mm512_slli_epi16(y4, 2);					\
	y3 = _mm512_slli_epi16(y3, 2);					\
	_mm512_storeu_si512((__m512i*)(pDstY), y1);		\
	_mm512_storeu_si512((__m512i*)(pDstY + 32), y2);	\
	_mm512_storeu_si512((__m512i*)(pDstU), y4);		\
	_mm512_storeu_si512((__m512i*)(pDstV), y3);		\
	pSrcY += uStep<<1;							\
	pDstY += uStep;								\
	pDstU += uStep>>1;							\
	pDstV += uStep>>1;							\
}

#ifdef _AVX512
void UYVYToYUV422P10DI_avx512(PBYTE pbDstY, PBYTE pbDstU, PBYTE pbDstV, INT iDstYStride, INT iDstUvStride,
	PBYTE pbSrcY, PBYTE pbSrcU, PBYTE pbSrcV, INT iSrcYStride, INT iSrcUvStride,
	UINT uWidth, INT iHeight)
{
	INT iSrcShift = (iDstBitDepth - iSrcBitDepth) < 0 ? 0 : (iDstBitDepth - iSrcBitDepth);
	INT iDstShift = (iSrcBitDepth - iDstBitDepth) < 0 ? 0 : (iSrcBitDepth - iDstBitDepth);

	SrcT *pSrcY = (SrcT *)pbSrcY;
	DstT *pDstY = (DstT *)pbDstY;
	DstT *pDstU = (DstT *)pbDstU;
	DstT *pDstV = (DstT *)pbDstV;
	INT uStep = 0;
	INT uNum = uWidth;
	__m512i y1, y2, y3, y4, y5, y6, y7, y8;
	__m512i u1, u2, u3, u4, u5, u6;
	INT x;
	__m512i mZero = _mm512_setzero_si512 ();
	__m512i mMask = _mm512_set1_epi16(0xFF);
	__m512i mMask16 = _mm512_set1_epi32(0xFFFF);
	__m512i mIdx = _mm512_setr_epi32(0x00010000, 0x00030002, 0x00090008, 0x000b000a, 0x00110010, 0x00130012, 0x00190018, 0x001b001a, 
									 0x00050004, 0x00070006, 0x000d000c, 0x000f000e, 0x00150014, 0x00170016, 0x001d001c, 0x001f001e);

	{
		uStep = 64;
		uNum = uWidth >> 6;
	}

	iSrcYStride >>= sizeof(SrcT) - 1;
	iDstYStride >>= sizeof(DstT) - 1;
	iDstUvStride >>= sizeof(DstT)- 1;

	if(iHeight < 0)
	{
		iHeight = -iHeight;
		pDstY += (iHeight-1) * iDstYStride;
		iDstYStride = -iDstYStride;
		iDstUvStride = -iDstUvStride;
	}

	INT iSrcYDif  = iSrcYStride - (uWidth<<1);
	INT iDstUvDif = iDstUvStride - (uWidth>>1);
	INT iDstYDif  = iDstYStride - uWidth;
	INT iH = iHeight - 2;

	//top line
	{
		UYVY_YUV422P10_AVX2_TOP();

		for(x = uWidth & (uStep - 1); x; x -= 2)
		{
			pDstY[0] = (DstT)_BitConv(pSrcY[1], iSrcShift, iDstShift);
			pDstY[1] = (DstT)_BitConv(pSrcY[3], iSrcShift, iDstShift);
			pDstU[0] = (DstT)_BitConv(pSrcY[0], iSrcShift, iDstShift);
			pDstV[0] = (DstT)_BitConv(pSrcY[2], iSrcShift, iDstShift);
			pDstY += 2;
			pDstU ++;
			pDstV ++;
			pSrcY += 4;
		}
		pDstY += iDstYDif;
		pDstU += iDstUvDif ;
		pDstV += iDstUvDif;
		pSrcY += iSrcYDif;
	}

	pSrcY -= iSrcYStride;

	for(int y = iH; y; y--)
	{

		for (x = uNum; x; x--)							
		{												
			y1 = _mm512_loadu_si512((__m512i*)(pSrcY));		
			y2 = _mm512_loadu_si512((__m512i*)(pSrcY + 64));	
			y3 = _mm512_loadu_si512((__m512i*)(pSrcY + iSrcYStride));	
			y4 = _mm512_loadu_si512((__m512i*)(pSrcY + iSrcYStride + 64));	
			y5 = _mm512_loadu_si512((__m512i*)(pSrcY + iSrcYStride * 2));	
			y6 = _mm512_loadu_si512((__m512i*)(pSrcY + iSrcYStride * 2 + 64));	
			u1 = _mm512_and_si512(y1, mMask);			
			u2 = _mm512_and_si512(y2, mMask);			
			u3 = _mm512_and_si512(y3, mMask);			
			u4 = _mm512_and_si512(y4, mMask);			
			u5 = _mm512_and_si512(y5, mMask);			
			u6 = _mm512_and_si512(y6, mMask);			
			y1 = _mm512_srli_epi16(y1, 8);					
			y2 = _mm512_srli_epi16(y2, 8);					
			y3 = _mm512_srli_epi16(y3, 8);					
			y4 = _mm512_srli_epi16(y4, 8);					
			y5 = _mm512_srli_epi16(y5, 8);					
			y6 = _mm512_srli_epi16(y6, 8);					
			y1 = _mm512_slli_epi16(y1, 2);					
			y2 = _mm512_slli_epi16(y2, 2);					
			y3 = _mm512_slli_epi16(y3, 2);					
			y4 = _mm512_slli_epi16(y4, 2);					
			y5 = _mm512_slli_epi16(y5, 2);					
			y6 = _mm512_slli_epi16(y6, 2);					
			u1 = _mm512_slli_epi16(u1, 2);					
			u2 = _mm512_slli_epi16(u2, 2);					
			u3 = _mm512_slli_epi16(u3, 2);					
			u4 = _mm512_slli_epi16(u4, 2);					
			u5 = _mm512_slli_epi16(u5, 2);					
			u6 = _mm512_slli_epi16(u6, 2);					
			y1 = _mm512_avg_epu16(y1, y5);					
			y2 = _mm512_avg_epu16(y2, y6);					
			y1 = _mm512_avg_epu16(y1, y3);					
			y2 = _mm512_avg_epu16(y2, y4);					
			u1 = _mm512_avg_epu16(u1, u5);					
			u2 = _mm512_avg_epu16(u2, u6);					
			u1 = _mm512_avg_epu16(u1, u3);					
			u2 = _mm512_avg_epu16(u2, u4);					
			u3 = _mm512_and_si512(u1, mMask16);			
			u4 = _mm512_and_si512(u2, mMask16);			
			u1 = _mm512_srli_epi32(u1, 16);				
			u2 = _mm512_srli_epi32(u2, 16);				
			u3 = _mm512_packus_epi32(u3, u4);				
			u1 = _mm512_packus_epi32(u1, u2);				
			u3 = _mm512_permutexvar_epi16(mIdx, u3);		
			u1 = _mm512_permutexvar_epi16(mIdx, u1);		
			_mm512_storeu_si512((__m512i*)(pDstY), y1);		
			_mm512_storeu_si512((__m512i*)(pDstY + 32), y2);	
			_mm512_storeu_si512((__m512i*)(pDstU), u3);		
			_mm512_storeu_si512((__m512i*)(pDstV), u1);		
			pSrcY += uStep<<1;							
			pDstY += uStep;								
			pDstU += uStep>>1;							
			pDstV += uStep>>1;							
		}

		for(x = uWidth & (uStep - 1); x; x -= 2)
		{
			pDstU[0] = (DstT)_DI_BOB_3(pSrcY[0], pSrcY[iSrcYStride],   pSrcY[iSrcYStride*2],   iSrcShift, iDstShift);
			pDstY[0] = (DstT)_DI_BOB_3(pSrcY[1], pSrcY[iSrcYStride+1], pSrcY[iSrcYStride*2+1], iSrcShift, iDstShift);
			pDstV[0] = (DstT)_DI_BOB_3(pSrcY[2], pSrcY[iSrcYStride+2], pSrcY[iSrcYStride*2+2], iSrcShift, iDstShift);
			pDstY[1] = (DstT)_DI_BOB_3(pSrcY[3], pSrcY[iSrcYStride+3], pSrcY[iSrcYStride*2+3], iSrcShift, iDstShift);

			pDstY +=2;
			pDstU ++;
			pDstV ++;
			pSrcY +=4;
		}

		pSrcY += iSrcYDif;
		pDstU += iDstUvDif;
		pDstV += iDstUvDif;
		pDstY += iDstYDif;
	}

	//bottom line
	{
		pSrcY += iSrcYStride;

		UYVY_YUV422P10_AVX2_TOP();

		for(x = uWidth & (uStep - 1); x; x -= 2)
		{
			pDstY[0] = (DstT)_BitConv(pSrcY[1], iSrcShift, iDstShift);
			pDstY[1] = (DstT)_BitConv(pSrcY[3], iSrcShift, iDstShift);
			pDstU[0] = (DstT)_BitConv(pSrcY[0], iSrcShift, iDstShift);
			pDstV[0] = (DstT)_BitConv(pSrcY[2], iSrcShift, iDstShift);
			pDstY += 2;
			pDstU ++;
			pDstV ++;
			pSrcY += 4;
		}
	}
}
#endif
